#!/usr/bin/zsh
# Copyright FlintFam Systems Management, 2013.
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

DIR=`pwd`
FILES=""

for i in $@; do
    FILES="$FILES \"$i\""
done

ORGBASEDIR=''
ORGLDIR="${ORGBASEDIR}/lisp/"
ORGCONTRIB="${ORGBASEDIR}/contrib/"


emacs -Q --batch \
    --eval "(progn
     (add-to-list 'load-path (expand-file-name \"$ORGLDIR\"))
     (add-to-list 'load-path (expand-file-name \"$ORGCONTRIB\" t))
     (require 'org)(require 'org-exp)(require 'ob)(require 'ob-tangle)
     (mapc (lambda (file)
            (find-file (expand-file-name file \"$DIR\"))
            (org-babel-tangle)
            (kill-buffer)) '($FILES)))" 2>&1 |grep tangled
